/* gpx-parser.c generated by valac, the Vala compiler
 * generated from gpx-parser.vala, do not modify */

/* Gpx Viewer
 * Copyright (C) 2009-2009 Qball Cow <qball@sarine.nl>
 * Project homepage: http://blog.sarine.nl/

 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <stdio.h>
#include <gio/gio.h>
#include <libxml/tree.h>
#include <libxml/xmlreader.h>
#include <libxml/xmlIO.h>
#include <gobject/gvaluecollector.h>


#define GPX_TYPE_POINT (gpx_point_get_type ())
#define GPX_POINT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPX_TYPE_POINT, GpxPoint))
#define GPX_POINT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPX_TYPE_POINT, GpxPointClass))
#define GPX_IS_POINT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPX_TYPE_POINT))
#define GPX_IS_POINT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPX_TYPE_POINT))
#define GPX_POINT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPX_TYPE_POINT, GpxPointClass))

typedef struct _GpxPoint GpxPoint;
typedef struct _GpxPointClass GpxPointClass;
typedef struct _GpxPointPrivate GpxPointPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _gpx_point_unref0(var) ((var == NULL) ? NULL : (var = (gpx_point_unref (var), NULL)))
typedef struct _GpxParamSpecPoint GpxParamSpecPoint;

#define GPX_TYPE_TRACK (gpx_track_get_type ())
#define GPX_TRACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPX_TYPE_TRACK, GpxTrack))
#define GPX_TRACK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPX_TYPE_TRACK, GpxTrackClass))
#define GPX_IS_TRACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPX_TYPE_TRACK))
#define GPX_IS_TRACK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPX_TYPE_TRACK))
#define GPX_TRACK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPX_TYPE_TRACK, GpxTrackClass))

typedef struct _GpxTrack GpxTrack;
typedef struct _GpxTrackClass GpxTrackClass;
typedef struct _GpxTrackPrivate GpxTrackPrivate;
#define __g_list_free_gpx_point_unref0(var) ((var == NULL) ? NULL : (var = (_g_list_free_gpx_point_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GPX_TYPE_FILE (gpx_file_get_type ())
#define GPX_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPX_TYPE_FILE, GpxFile))
#define GPX_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPX_TYPE_FILE, GpxFileClass))
#define GPX_IS_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPX_TYPE_FILE))
#define GPX_IS_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPX_TYPE_FILE))
#define GPX_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPX_TYPE_FILE, GpxFileClass))

typedef struct _GpxFile GpxFile;
typedef struct _GpxFileClass GpxFileClass;
typedef struct _GpxFilePrivate GpxFilePrivate;
#define __g_list_free_g_object_unref0(var) ((var == NULL) ? NULL : (var = (_g_list_free_g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _xmlFreeTextReader0(var) ((var == NULL) ? NULL : (var = (xmlFreeTextReader (var), NULL)))

struct _GpxPoint {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GpxPointPrivate * priv;
	double lat;
	double lon;
	double lat_dec;
	double lon_dec;
	double distance;
	double elevation;
	char* time;
	double speed;
};

struct _GpxPointClass {
	GTypeClass parent_class;
	void (*finalize) (GpxPoint *self);
};

struct _GpxPointPrivate {
	char* _name;
	time_t utime;
};

struct _GpxParamSpecPoint {
	GParamSpec parent_instance;
};

struct _GpxTrack {
	GObject parent_instance;
	GpxTrackPrivate * priv;
	double total_distance;
	double max_speed;
	GList* points;
	GpxPoint* top;
	GpxPoint* bottom;
	double max_elevation;
	double min_elevation;
};

struct _GpxTrackClass {
	GObjectClass parent_class;
};

struct _GpxTrackPrivate {
	char* _name;
	GpxPoint* last;
};

struct _GpxFile {
	GObject parent_instance;
	GpxFilePrivate * priv;
	GList* tracks;
	GList* waypoints;
	GList* routes;
	GFile* file;
};

struct _GpxFileClass {
	GObjectClass parent_class;
};

struct _GpxFilePrivate {
	GFileInputStream* stream;
};


static gpointer gpx_point_parent_class = NULL;
static gpointer gpx_track_parent_class = NULL;
static gpointer gpx_file_parent_class = NULL;

gpointer gpx_point_ref (gpointer instance);
void gpx_point_unref (gpointer instance);
GParamSpec* gpx_param_spec_point (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void gpx_value_set_point (GValue* value, gpointer v_object);
void gpx_value_take_point (GValue* value, gpointer v_object);
gpointer gpx_value_get_point (const GValue* value);
GType gpx_point_get_type (void) G_GNUC_CONST;
#define GPX_POINT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GPX_TYPE_POINT, GpxPointPrivate))
enum  {
	GPX_POINT_DUMMY_PROPERTY
};
GpxPoint* gpx_point_new (void);
GpxPoint* gpx_point_construct (GType object_type);
const char* gpx_point_get_name (GpxPoint* self);
void gpx_point_set_name (GpxPoint* self, const char* value);
GpxPoint* gpx_point_copy (GpxPoint* self);
void gpx_point_set_position (GpxPoint* self, double lat, double lon);
time_t gpx_point_get_time (GpxPoint* self);
static void gpx_point_finalize (GpxPoint* obj);
GType gpx_track_get_type (void) G_GNUC_CONST;
#define GPX_TRACK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GPX_TYPE_TRACK, GpxTrackPrivate))
enum  {
	GPX_TRACK_DUMMY_PROPERTY,
	GPX_TRACK_NAME
};
static void _g_list_free_gpx_point_unref (GList* self);
static double gpx_track_calculate_distance (GpxTrack* self, GpxPoint* a, GpxPoint* b);
double gpx_track_calculate_point_to_point_speed (GpxTrack* self, GpxPoint* a, GpxPoint* b);
void gpx_track_add_point (GpxTrack* self, GpxPoint* point);
GpxTrack* gpx_track_new (void);
GpxTrack* gpx_track_construct (GType object_type);
const char* gpx_track_get_name (GpxTrack* self);
void gpx_track_set_name (GpxTrack* self, const char* value);
double gpx_track_get_track_average (GpxTrack* self);
GpxTrack* gpx_track_cleanup_speed (GpxTrack* self);
time_t gpx_track_get_total_time (GpxTrack* self);
double gpx_track_calculate_moving_average (GpxTrack* self, GpxPoint* start, GpxPoint* stop, time_t* moving_time);
static void gpx_track_finalize (GObject* obj);
static void gpx_track_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void gpx_track_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType gpx_file_get_type (void) G_GNUC_CONST;
#define GPX_FILE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GPX_TYPE_FILE, GpxFilePrivate))
enum  {
	GPX_FILE_DUMMY_PROPERTY
};
static void _g_list_free_g_object_unref (GList* self);
static void gpx_file_parse_track (GpxFile* self, xmlNode* node);
static void gpx_file_parse_waypoint (GpxFile* self, xmlNode* node);
static void gpx_file_parse_route (GpxFile* self, xmlNode* node);
static gint gpx_file_read_file (GpxFile* self, gchar* buffer, int buffer_length1);
static gint gpx_file_close_file (GpxFile* self);
GpxFile* gpx_file_new (GFile* file);
GpxFile* gpx_file_construct (GType object_type, GFile* file);
static void gpx_file_finalize (GObject* obj);
static int _vala_strcmp0 (const char * str1, const char * str2);



GpxPoint* gpx_point_copy (GpxPoint* self) {
	GpxPoint* result = NULL;
	GpxPoint* p;
	char* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	p = gpx_point_new ();
	gpx_point_set_name (p, self->priv->_name);
	p->lat = self->lat;
	p->lon = self->lon;
	p->lat_dec = self->lat_dec;
	p->lon_dec = self->lon_dec;
	p->time = (_tmp0_ = g_strdup (self->time), _g_free0 (p->time), _tmp0_);
	p->elevation = self->elevation;
	result = p;
	return result;
}


void gpx_point_set_position (GpxPoint* self, double lat, double lon) {
	g_return_if_fail (self != NULL);
	self->lat_dec = lat;
	self->lon_dec = lon;
	self->lat = ((2 * G_PI) * lat) / 360.0;
	self->lon = ((2 * G_PI) * lon) / 360.0;
}


time_t gpx_point_get_time (GpxPoint* self) {
	time_t result;
	struct tm ta = {0};
	if (self->time == NULL) {
		result = (time_t) 0;
		return result;
	}
	if (self->priv->utime > 0) {
		result = self->priv->utime;
		return result;
	}
	memset (&ta, 0, sizeof (struct tm));
	strptime (self->time, "%FT%T%z", &ta);
	self->priv->utime = mktime (&ta);
	result = self->priv->utime;
	return result;
}


GpxPoint* gpx_point_construct (GType object_type) {
	GpxPoint* self;
	self = (GpxPoint*) g_type_create_instance (object_type);
	return self;
}


GpxPoint* gpx_point_new (void) {
	return gpx_point_construct (GPX_TYPE_POINT);
}


const char* gpx_point_get_name (GpxPoint* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_name;
	return result;
}


void gpx_point_set_name (GpxPoint* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_name = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_name), _tmp0_);
}


static void gpx_value_point_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void gpx_value_point_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		gpx_point_unref (value->data[0].v_pointer);
	}
}


static void gpx_value_point_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = gpx_point_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer gpx_value_point_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* gpx_value_point_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		GpxPoint* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = gpx_point_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* gpx_value_point_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	GpxPoint** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = gpx_point_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* gpx_param_spec_point (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	GpxParamSpecPoint* spec;
	g_return_val_if_fail (g_type_is_a (object_type, GPX_TYPE_POINT), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer gpx_value_get_point (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GPX_TYPE_POINT), NULL);
	return value->data[0].v_pointer;
}


void gpx_value_set_point (GValue* value, gpointer v_object) {
	GpxPoint* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GPX_TYPE_POINT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GPX_TYPE_POINT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		gpx_point_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gpx_point_unref (old);
	}
}


void gpx_value_take_point (GValue* value, gpointer v_object) {
	GpxPoint* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GPX_TYPE_POINT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GPX_TYPE_POINT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gpx_point_unref (old);
	}
}


static void gpx_point_class_init (GpxPointClass * klass) {
	gpx_point_parent_class = g_type_class_peek_parent (klass);
	GPX_POINT_CLASS (klass)->finalize = gpx_point_finalize;
	g_type_class_add_private (klass, sizeof (GpxPointPrivate));
}


static void gpx_point_instance_init (GpxPoint * self) {
	self->priv = GPX_POINT_GET_PRIVATE (self);
	self->priv->_name = NULL;
	self->lat = (double) 1000;
	self->lon = (double) 1000;
	self->lat_dec = (double) 1000;
	self->lon_dec = (double) 1000;
	self->distance = (double) 0;
	self->speed = (double) 0;
	self->priv->utime = (time_t) 0;
	self->ref_count = 1;
}


static void gpx_point_finalize (GpxPoint* obj) {
	GpxPoint * self;
	self = GPX_POINT (obj);
	_g_free0 (self->priv->_name);
	_g_free0 (self->time);
}


GType gpx_point_get_type (void) {
	static volatile gsize gpx_point_type_id__volatile = 0;
	if (g_once_init_enter (&gpx_point_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { gpx_value_point_init, gpx_value_point_free_value, gpx_value_point_copy_value, gpx_value_point_peek_pointer, "p", gpx_value_point_collect_value, "p", gpx_value_point_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GpxPointClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpx_point_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GpxPoint), 0, (GInstanceInitFunc) gpx_point_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType gpx_point_type_id;
		gpx_point_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GpxPoint", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&gpx_point_type_id__volatile, gpx_point_type_id);
	}
	return gpx_point_type_id__volatile;
}


gpointer gpx_point_ref (gpointer instance) {
	GpxPoint* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void gpx_point_unref (gpointer instance) {
	GpxPoint* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		GPX_POINT_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void _g_list_free_gpx_point_unref (GList* self) {
	g_list_foreach (self, (GFunc) gpx_point_unref, NULL);
	g_list_free (self);
}


static gpointer _gpx_point_ref0 (gpointer self) {
	return self ? gpx_point_ref (self) : NULL;
}


void gpx_track_add_point (GpxTrack* self, GpxPoint* point) {
	GpxPoint* _tmp13_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (point != NULL);
	point->speed = 0.0;
	if (self->priv->last != NULL) {
		double distance;
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
		gboolean _tmp10_ = FALSE;
		gboolean _tmp11_ = FALSE;
		distance = gpx_track_calculate_distance (self, self->priv->last, point);
		self->total_distance = self->total_distance + distance;
		point->distance = self->total_distance;
		if (self->priv->last->time != NULL) {
			_tmp0_ = point->time != NULL;
		} else {
			_tmp0_ = FALSE;
		}
		if (_tmp0_) {
			point->speed = gpx_track_calculate_point_to_point_speed (self, self->priv->last, point);
			if (point->speed > self->max_speed) {
				self->max_speed = point->speed;
			}
			if (point->elevation > self->max_elevation) {
				self->max_elevation = point->elevation;
			}
			if (point->elevation < self->min_elevation) {
				self->min_elevation = point->elevation;
			}
		}
		if (self->top == NULL) {
			_tmp2_ = TRUE;
		} else {
			_tmp2_ = self->top->lat_dec == 1000;
		}
		if (_tmp2_) {
			_tmp1_ = TRUE;
		} else {
			_tmp1_ = self->top->lat_dec > point->lat_dec;
		}
		if (_tmp1_) {
			if (self->top == NULL) {
				GpxPoint* _tmp3_;
				self->top = (_tmp3_ = gpx_point_new (), _gpx_point_unref0 (self->top), _tmp3_);
			}
			self->top->lat_dec = point->lat_dec;
		}
		if (self->top == NULL) {
			_tmp5_ = TRUE;
		} else {
			_tmp5_ = self->top->lon_dec == 1000;
		}
		if (_tmp5_) {
			_tmp4_ = TRUE;
		} else {
			_tmp4_ = self->top->lon_dec > point->lon_dec;
		}
		if (_tmp4_) {
			if (self->top == NULL) {
				GpxPoint* _tmp6_;
				self->top = (_tmp6_ = gpx_point_new (), _gpx_point_unref0 (self->top), _tmp6_);
			}
			self->top->lon_dec = point->lon_dec;
		}
		if (self->bottom == NULL) {
			_tmp8_ = TRUE;
		} else {
			_tmp8_ = self->bottom->lat_dec == 1000;
		}
		if (_tmp8_) {
			_tmp7_ = TRUE;
		} else {
			_tmp7_ = self->bottom->lat_dec < point->lat_dec;
		}
		if (_tmp7_) {
			if (self->bottom == NULL) {
				GpxPoint* _tmp9_;
				self->bottom = (_tmp9_ = gpx_point_new (), _gpx_point_unref0 (self->bottom), _tmp9_);
			}
			self->bottom->lat_dec = point->lat_dec;
		}
		if (self->bottom == NULL) {
			_tmp11_ = TRUE;
		} else {
			_tmp11_ = self->bottom->lon_dec == 1000;
		}
		if (_tmp11_) {
			_tmp10_ = TRUE;
		} else {
			_tmp10_ = self->bottom->lon_dec < point->lon_dec;
		}
		if (_tmp10_) {
			if (self->bottom == NULL) {
				GpxPoint* _tmp12_;
				self->bottom = (_tmp12_ = gpx_point_new (), _gpx_point_unref0 (self->bottom), _tmp12_);
			}
			self->bottom->lon_dec = point->lon_dec;
		}
	} else {
		self->max_elevation = point->elevation;
		self->min_elevation = point->elevation;
	}
	self->points = g_list_append (self->points, _gpx_point_ref0 (point));
	self->priv->last = (_tmp13_ = _gpx_point_ref0 (point), _gpx_point_unref0 (self->priv->last), _tmp13_);
}


GpxTrack* gpx_track_cleanup_speed (GpxTrack* self) {
	GpxTrack* result = NULL;
	GpxTrack* retv;
	guint num_points;
	double mean;
	double deviation;
	GList* list_copy;
	GList* iter;
	double sqrt_deviation;
	guint i;
	g_return_val_if_fail (self != NULL, NULL);
	retv = gpx_track_new ();
	gpx_track_set_name (retv, self->priv->_name);
	num_points = g_list_length (self->points);
	mean = gpx_track_get_track_average (self);
	deviation = 0.0;
	list_copy = g_list_copy (self->points);
	iter = g_list_first (list_copy);
	while (TRUE) {
		double diff;
		if (!(iter != NULL)) {
			break;
		}
		diff = ((GpxPoint*) iter->data)->speed - mean;
		deviation = deviation + (diff * diff);
		iter = iter->next;
	}
	deviation = deviation / ((double) num_points);
	sqrt_deviation = sqrt (deviation);
	g_debug ("gpx-parser.vala:178: Standard deviation: %f  mean: %f %u\n", sqrt_deviation, mean, num_points);
	iter = g_list_first (list_copy);
	i = (guint) 0;
	while (TRUE) {
		double pspeed;
		double pdf;
		if (!(iter != NULL)) {
			break;
		}
		pspeed = ((GpxPoint*) iter->data)->speed;
		if (iter->next != NULL) {
			pspeed = ((GpxPoint*) iter->next->data)->speed;
		}
		pdf = (1 / sqrt ((2 * G_PI) * deviation)) * exp ((-((pspeed - mean) * (pspeed - mean))) / (2 * deviation));
		if ((num_points * pdf) < 0.1) {
			GList* temp;
			temp = iter->prev;
			list_copy = g_list_remove_link (list_copy, iter);
			fprintf (stdout, "%u del: %f\n", i, pspeed);
			if (temp != NULL) {
				iter = temp;
				if (iter->next != NULL) {
					((GpxPoint*) iter->next->data)->speed = gpx_track_calculate_point_to_point_speed (self, (GpxPoint*) iter->data, (GpxPoint*) iter->next->data);
					fprintf (stdout, "%u new speed: %f\n", i, ((GpxPoint*) iter->next->data)->speed);
				}
			} else {
				i = (guint) 0;
				fprintf (stdout, "%u goto first\n", i);
				iter = g_list_first (list_copy);
				((GpxPoint*) iter->data)->speed = 0.0;
				((GpxPoint*) iter->data)->distance = 0.0;
				if (iter->next != NULL) {
					((GpxPoint*) iter->next->data)->distance = gpx_track_calculate_distance (self, (GpxPoint*) iter->data, (GpxPoint*) iter->next->data);
					((GpxPoint*) iter->next->data)->speed = gpx_track_calculate_point_to_point_speed (self, (GpxPoint*) iter->data, (GpxPoint*) iter->next->data);
					fprintf (stdout, "%u new speed: %f\n", i, ((GpxPoint*) iter->next->data)->speed);
				}
			}
		} else {
			iter = iter->next;
			i++;
		}
	}
	iter = g_list_first (list_copy);
	while (TRUE) {
		if (!(iter != NULL)) {
			break;
		}
		gpx_track_add_point (retv, (GpxPoint*) iter->data);
		iter = iter->next;
	}
	result = retv;
	__g_list_free_gpx_point_unref0 (list_copy);
	return result;
}


double gpx_track_get_track_average (GpxTrack* self) {
	double result = 0.0;
	GList* first;
	GList* last;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, 0.0);
	first = g_list_first (self->points);
	last = g_list_last (self->points);
	if (first != NULL) {
		_tmp0_ = last != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = gpx_track_calculate_point_to_point_speed (self, (GpxPoint*) first->data, (GpxPoint*) last->data);
		return result;
	}
	result = (double) 0;
	return result;
}


double gpx_track_calculate_point_to_point_speed (GpxTrack* self, GpxPoint* a, GpxPoint* b) {
	double result = 0.0;
	double dist;
	gboolean _tmp0_ = FALSE;
	time_t ta;
	time_t tb;
	g_return_val_if_fail (self != NULL, 0.0);
	g_return_val_if_fail (a != NULL, 0.0);
	g_return_val_if_fail (b != NULL, 0.0);
	dist = b->distance - a->distance;
	if (a->time == NULL) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = b->time == NULL;
	}
	if (_tmp0_) {
		result = (double) 0;
		return result;
	}
	ta = gpx_point_get_time (a);
	tb = gpx_point_get_time (b);
	if ((tb - ta) == 0) {
		result = (double) 0;
		return result;
	}
	result = dist / ((tb - ta) / (60.0 * 60.0));
	return result;
}


time_t gpx_track_get_total_time (GpxTrack* self) {
	time_t result;
	GpxPoint* a;
	GpxPoint* b;
	GList* na;
	GList* nb;
	gboolean _tmp0_ = FALSE;
	GpxPoint* _tmp1_;
	GpxPoint* _tmp2_;
	time_t time;
	a = NULL;
	b = NULL;
	na = g_list_first (self->points);
	nb = g_list_last (self->points);
	if (na == NULL) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = nb == NULL;
	}
	if (_tmp0_) {
		result = (time_t) 0;
		_gpx_point_unref0 (b);
		_gpx_point_unref0 (a);
		return result;
	}
	a = (_tmp1_ = _gpx_point_ref0 ((GpxPoint*) na->data), _gpx_point_unref0 (a), _tmp1_);
	b = (_tmp2_ = _gpx_point_ref0 ((GpxPoint*) nb->data), _gpx_point_unref0 (b), _tmp2_);
	time = gpx_point_get_time (b) - gpx_point_get_time (a);
	result = time;
	_gpx_point_unref0 (b);
	_gpx_point_unref0 (a);
	return result;
}


double gpx_track_calculate_moving_average (GpxTrack* self, GpxPoint* start, GpxPoint* stop, time_t* moving_time) {
	double result = 0.0;
	double time;
	double distance;
	GList* iter;
	g_return_val_if_fail (self != NULL, 0.0);
	g_return_val_if_fail (start != NULL, 0.0);
	g_return_val_if_fail (stop != NULL, 0.0);
	time = (double) 0;
	distance = (double) 0;
	*moving_time = (time_t) 0;
	iter = g_list_find (self->points, start);
	if (iter == NULL) {
		result = (double) 0;
		return result;
	}
	if (iter != NULL) {
		while (TRUE) {
			gboolean _tmp0_ = FALSE;
			GpxPoint* b;
			if ((iter = iter->next) != NULL) {
				_tmp0_ = ((GpxPoint*) iter->prev->data) != stop;
			} else {
				_tmp0_ = FALSE;
			}
			if (!_tmp0_) {
				break;
			}
			b = _gpx_point_ref0 ((GpxPoint*) iter->data);
			if ((((b->distance - ((GpxPoint*) iter->prev->data)->distance) * 3600) / (gpx_point_get_time (b) - gpx_point_get_time ((GpxPoint*) iter->prev->data))) > 1.0) {
				time = time + ((double) (gpx_point_get_time (b) - gpx_point_get_time ((GpxPoint*) iter->prev->data)));
				distance = distance + (b->distance - ((GpxPoint*) iter->prev->data)->distance);
			}
			_gpx_point_unref0 (b);
		}
	}
	*moving_time = (time_t) time;
	result = distance / (time / (60.0 * 60.0));
	return result;
}


static double gpx_track_calculate_distance (GpxTrack* self, GpxPoint* a, GpxPoint* b) {
	double result = 0.0;
	double retv;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, 0.0);
	g_return_val_if_fail (a != NULL, 0.0);
	g_return_val_if_fail (b != NULL, 0.0);
	retv = (double) 0;
	if (a->lat == b->lat) {
		_tmp0_ = a->lon == b->lon;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = (double) 0;
		return result;
	}
	retv = 6378.7 * acos ((sin (a->lat) * sin (b->lat)) + ((cos (a->lat) * cos (b->lat)) * cos (b->lon - a->lon)));
	if (isnan (retv) == 1) {
		result = (double) 0;
		return result;
	}
	result = retv;
	return result;
}


GpxTrack* gpx_track_construct (GType object_type) {
	GpxTrack * self;
	self = (GpxTrack*) g_object_new (object_type, NULL);
	return self;
}


GpxTrack* gpx_track_new (void) {
	return gpx_track_construct (GPX_TYPE_TRACK);
}


const char* gpx_track_get_name (GpxTrack* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_name;
	return result;
}


void gpx_track_set_name (GpxTrack* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_name = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_name), _tmp0_);
	g_object_notify ((GObject *) self, "name");
}


static void gpx_track_class_init (GpxTrackClass * klass) {
	gpx_track_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GpxTrackPrivate));
	G_OBJECT_CLASS (klass)->get_property = gpx_track_get_property;
	G_OBJECT_CLASS (klass)->set_property = gpx_track_set_property;
	G_OBJECT_CLASS (klass)->finalize = gpx_track_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPX_TRACK_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void gpx_track_instance_init (GpxTrack * self) {
	self->priv = GPX_TRACK_GET_PRIVATE (self);
	self->priv->_name = NULL;
	self->total_distance = 0.0;
	self->max_speed = (double) 0;
	self->points = NULL;
	self->priv->last = NULL;
	self->top = NULL;
	self->bottom = NULL;
	self->max_elevation = 0.0;
	self->min_elevation = 0.0;
}


static void gpx_track_finalize (GObject* obj) {
	GpxTrack * self;
	self = GPX_TRACK (obj);
	_g_free0 (self->priv->_name);
	__g_list_free_gpx_point_unref0 (self->points);
	_gpx_point_unref0 (self->priv->last);
	_gpx_point_unref0 (self->top);
	_gpx_point_unref0 (self->bottom);
	G_OBJECT_CLASS (gpx_track_parent_class)->finalize (obj);
}


GType gpx_track_get_type (void) {
	static volatile gsize gpx_track_type_id__volatile = 0;
	if (g_once_init_enter (&gpx_track_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GpxTrackClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpx_track_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GpxTrack), 0, (GInstanceInitFunc) gpx_track_instance_init, NULL };
		GType gpx_track_type_id;
		gpx_track_type_id = g_type_register_static (G_TYPE_OBJECT, "GpxTrack", &g_define_type_info, 0);
		g_once_init_leave (&gpx_track_type_id__volatile, gpx_track_type_id);
	}
	return gpx_track_type_id__volatile;
}


static void gpx_track_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GpxTrack * self;
	self = GPX_TRACK (object);
	switch (property_id) {
		case GPX_TRACK_NAME:
		g_value_set_string (value, gpx_track_get_name (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void gpx_track_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GpxTrack * self;
	self = GPX_TRACK (object);
	switch (property_id) {
		case GPX_TRACK_NAME:
		gpx_track_set_name (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _g_list_free_g_object_unref (GList* self) {
	g_list_foreach (self, (GFunc) g_object_unref, NULL);
	g_list_free (self);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void gpx_file_parse_track (GpxFile* self, xmlNode* node) {
	GpxTrack* track;
	xmlNode* trkseg;
	g_return_if_fail (self != NULL);
	track = gpx_track_new ();
	trkseg = node->children;
	while (TRUE) {
		if (!(trkseg != NULL)) {
			break;
		}
		if (_vala_strcmp0 (trkseg->name, "trkseg") == 0) {
			xmlNode* point;
			point = trkseg->children;
			while (TRUE) {
				if (!(point != NULL)) {
					break;
				}
				if (_vala_strcmp0 (point->name, "trkpt") == 0) {
					char* lat;
					char* lon;
					gboolean _tmp0_ = FALSE;
					lat = xmlGetProp (point, "lat");
					lon = xmlGetProp (point, "lon");
					if (lat != NULL) {
						_tmp0_ = lon != NULL;
					} else {
						_tmp0_ = FALSE;
					}
					if (_tmp0_) {
						GpxPoint* p;
						double flat;
						double flon;
						xmlNode* info;
						p = gpx_point_new ();
						flat = g_ascii_strtod (lat, NULL);
						flon = g_ascii_strtod (lon, NULL);
						gpx_point_set_position (p, flat, flon);
						info = point->children;
						while (TRUE) {
							if (!(info != NULL)) {
								break;
							}
							if (_vala_strcmp0 (info->name, "ele") == 0) {
								char* content;
								content = xmlNodeGetContent (info);
								if (content != NULL) {
									p->elevation = g_ascii_strtod (content, NULL);
								}
								_g_free0 (content);
							} else {
								if (_vala_strcmp0 (info->name, "time") == 0) {
									char* _tmp1_;
									p->time = (_tmp1_ = xmlNodeGetContent (info), _g_free0 (p->time), _tmp1_);
								}
							}
							info = info->next;
						}
						gpx_track_add_point (track, p);
						_gpx_point_unref0 (p);
					} else {
						g_message ("gpx-parser.vala:377: Failed to get point: %s\n", point->name);
					}
					_g_free0 (lon);
					_g_free0 (lat);
				}
				point = point->next;
			}
		}
		if (_vala_strcmp0 (trkseg->name, "name") == 0) {
			if (gpx_track_get_name (track) == NULL) {
				char* _tmp2_;
				gpx_track_set_name (track, _tmp2_ = xmlNodeGetContent (trkseg));
				_g_free0 (_tmp2_);
			} else {
				g_warning ("gpx-parser.vala:391: Track name allready set: %s\n", gpx_track_get_name (track));
			}
		}
		trkseg = trkseg->next;
	}
	self->tracks = g_list_append (self->tracks, _g_object_ref0 (track));
	_g_object_unref0 (track);
}


static void gpx_file_parse_waypoint (GpxFile* self, xmlNode* node) {
	char* lat;
	char* lon;
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	lat = xmlGetProp (node, "lat");
	lon = xmlGetProp (node, "lon");
	if (lat != NULL) {
		_tmp0_ = lon != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GpxPoint* p;
		double flat;
		double flon;
		xmlNode* info;
		p = gpx_point_new ();
		flat = g_ascii_strtod (lat, NULL);
		flon = g_ascii_strtod (lon, NULL);
		gpx_point_set_position (p, flat, flon);
		info = node->children;
		while (TRUE) {
			if (!(info != NULL)) {
				break;
			}
			if (_vala_strcmp0 (info->name, "name") == 0) {
				if (gpx_point_get_name (p) == NULL) {
					char* _tmp1_;
					gpx_point_set_name (p, _tmp1_ = xmlNodeGetContent (info));
					_g_free0 (_tmp1_);
				} else {
					g_warning ("gpx-parser.vala:421: Point name allready set: %s\n", gpx_point_get_name (p));
				}
			}
			info = info->next;
		}
		self->waypoints = g_list_append (self->waypoints, _gpx_point_ref0 (p));
		_gpx_point_unref0 (p);
	}
	_g_free0 (lon);
	_g_free0 (lat);
}


static void gpx_file_parse_route (GpxFile* self, xmlNode* node) {
	GpxTrack* track;
	xmlNode* trkseg;
	g_return_if_fail (self != NULL);
	track = gpx_track_new ();
	trkseg = node->children;
	while (TRUE) {
		if (!(trkseg != NULL)) {
			break;
		}
		if (_vala_strcmp0 (trkseg->name, "rtept") == 0) {
			char* lat;
			char* lon;
			gboolean _tmp0_ = FALSE;
			lat = xmlGetProp (trkseg, "lat");
			lon = xmlGetProp (trkseg, "lon");
			if (lat != NULL) {
				_tmp0_ = lon != NULL;
			} else {
				_tmp0_ = FALSE;
			}
			if (_tmp0_) {
				GpxPoint* p;
				double flat;
				double flon;
				xmlNode* info;
				p = gpx_point_new ();
				flat = g_ascii_strtod (lat, NULL);
				flon = g_ascii_strtod (lon, NULL);
				gpx_point_set_position (p, flat, flon);
				info = trkseg->children;
				while (TRUE) {
					if (!(info != NULL)) {
						break;
					}
					if (_vala_strcmp0 (info->name, "ele") == 0) {
						char* content;
						content = xmlNodeGetContent (info);
						if (content != NULL) {
							p->elevation = g_ascii_strtod (content, NULL);
						}
						_g_free0 (content);
					} else {
						if (_vala_strcmp0 (info->name, "time") == 0) {
							char* _tmp1_;
							p->time = (_tmp1_ = xmlNodeGetContent (info), _g_free0 (p->time), _tmp1_);
						}
					}
					info = info->next;
				}
				gpx_track_add_point (track, p);
				_gpx_point_unref0 (p);
			} else {
				g_message ("gpx-parser.vala:470: Failed to get trkseg: %s\n", trkseg->name);
			}
			_g_free0 (lon);
			_g_free0 (lat);
		} else {
			if (_vala_strcmp0 (trkseg->name, "name") == 0) {
				if (gpx_track_get_name (track) == NULL) {
					char* _tmp2_;
					gpx_track_set_name (track, _tmp2_ = xmlNodeGetContent (trkseg));
					_g_free0 (_tmp2_);
				} else {
					g_warning ("gpx-parser.vala:481: Track name allready set: %s\n", gpx_track_get_name (track));
				}
			}
		}
		trkseg = trkseg->next;
	}
	self->routes = g_list_append (self->routes, _g_object_ref0 (track));
	_g_object_unref0 (track);
}


static gint gpx_file_read_file (GpxFile* self, gchar* buffer, int buffer_length1) {
	gint result = 0;
	GError * _inner_error_;
	g_return_val_if_fail (self != NULL, 0);
	_inner_error_ = NULL;
	{
		gssize value;
		value = g_input_stream_read ((GInputStream*) self->priv->stream, buffer, (gsize) buffer_length1, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch0_g_error;
		}
		result = (gint) value;
		return result;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_critical ("gpx-parser.vala:505: error reading from stream: %s\n", e->message);
			result = -1;
			_g_error_free0 (e);
			return result;
		}
	}
	__finally0:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0;
	}
}


static gint gpx_file_close_file (GpxFile* self) {
	gint result = 0;
	GFileInputStream* _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	g_log ("GPX PARSER", G_LOG_LEVEL_DEBUG, "gpx-parser.vala:511: Close_file()");
	self->priv->stream = (_tmp0_ = NULL, _g_object_unref0 (self->priv->stream), _tmp0_);
	result = 0;
	return result;
}


GpxFile* gpx_file_construct (GType object_type, GFile* file) {
	GError * _inner_error_;
	GpxFile * self;
	GFile* _tmp0_;
	g_return_val_if_fail (file != NULL, NULL);
	_inner_error_ = NULL;
	self = (GpxFile*) g_object_new (object_type, NULL);
	self->file = (_tmp0_ = _g_object_ref0 (file), _g_object_unref0 (self->file), _tmp0_);
	{
		GFileInputStream* _tmp1_;
		GFileInputStream* _tmp2_;
		char* _tmp3_;
		xmlTextReader* _tmp4_;
		xmlTextReader* reader;
		_tmp1_ = g_file_read (file, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch1_g_error;
		}
		self->priv->stream = (_tmp2_ = _tmp1_, _g_object_unref0 (self->priv->stream), _tmp2_);
		reader = (_tmp4_ = xmlReaderForIO ((xmlInputReadCallback) gpx_file_read_file, (xmlInputCloseCallback) gpx_file_close_file, self, _tmp3_ = g_file_get_uri (self->file), "", 0), _g_free0 (_tmp3_), _tmp4_);
		if (reader != NULL) {
			gint doc;
			doc = xmlTextReaderRead (reader);
			while (TRUE) {
				char* name;
				if (!(doc == 1)) {
					break;
				}
				name = g_strdup (xmlTextReaderConstName (reader));
				if (_vala_strcmp0 (name, "gpx") == 0) {
					gint doc2;
					doc2 = xmlTextReaderRead (reader);
					while (TRUE) {
						char* name2;
						if (!(doc2 == 1)) {
							break;
						}
						name2 = g_strdup (xmlTextReaderConstName (reader));
						if (_vala_strcmp0 (name2, "trk") == 0) {
							xmlNode* node;
							node = xmlTextReaderExpand (reader);
							gpx_file_parse_track (self, node);
						} else {
							if (_vala_strcmp0 (name2, "wpt") == 0) {
								xmlNode* node;
								node = xmlTextReaderExpand (reader);
								gpx_file_parse_waypoint (self, node);
							} else {
								if (_vala_strcmp0 (name2, "rte") == 0) {
									xmlNode* node;
									node = xmlTextReaderExpand (reader);
									gpx_file_parse_route (self, node);
								}
							}
						}
						doc2 = xmlTextReaderNext (reader);
						_g_free0 (name2);
					}
				} else {
					doc = xmlTextReaderRead (reader);
				}
				_g_free0 (name);
			}
		} else {
			g_message ("gpx-parser.vala:568: Failed to open file");
		}
		xmlTextReaderClose (reader);
		_xmlFreeTextReader0 (reader);
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			char* _tmp5_;
			g_critical ("gpx-parser.vala:574: failed to open file: '%s' error: %s", _tmp5_ = g_file_get_uri (self->file), e->message);
			_g_free0 (_tmp5_);
			_g_error_free0 (e);
		}
	}
	__finally1:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	return self;
}


GpxFile* gpx_file_new (GFile* file) {
	return gpx_file_construct (GPX_TYPE_FILE, file);
}


static void gpx_file_class_init (GpxFileClass * klass) {
	gpx_file_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GpxFilePrivate));
	G_OBJECT_CLASS (klass)->finalize = gpx_file_finalize;
}


static void gpx_file_instance_init (GpxFile * self) {
	self->priv = GPX_FILE_GET_PRIVATE (self);
	self->tracks = NULL;
	self->waypoints = NULL;
	self->routes = NULL;
	self->file = NULL;
	self->priv->stream = NULL;
}


static void gpx_file_finalize (GObject* obj) {
	GpxFile * self;
	self = GPX_FILE (obj);
	__g_list_free_g_object_unref0 (self->tracks);
	__g_list_free_gpx_point_unref0 (self->waypoints);
	__g_list_free_g_object_unref0 (self->routes);
	_g_object_unref0 (self->file);
	_g_object_unref0 (self->priv->stream);
	G_OBJECT_CLASS (gpx_file_parent_class)->finalize (obj);
}


GType gpx_file_get_type (void) {
	static volatile gsize gpx_file_type_id__volatile = 0;
	if (g_once_init_enter (&gpx_file_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GpxFileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpx_file_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GpxFile), 0, (GInstanceInitFunc) gpx_file_instance_init, NULL };
		GType gpx_file_type_id;
		gpx_file_type_id = g_type_register_static (G_TYPE_OBJECT, "GpxFile", &g_define_type_info, 0);
		g_once_init_leave (&gpx_file_type_id__volatile, gpx_file_type_id);
	}
	return gpx_file_type_id__volatile;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




