/* gpx-track-treemodel.c generated by valac, the Vala compiler
 * generated from gpx-track-treemodel.vala, do not modify */

/* Gpx Viewer
 * Copyright (C) 2009-2010 Qball Cow <qball@sarine.nl>
 * Project homepage: http://blog.sarine.nl/

 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <time.h>


#define GPX_TYPE_TRACK_TREE_MODEL (gpx_track_tree_model_get_type ())
#define GPX_TRACK_TREE_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPX_TYPE_TRACK_TREE_MODEL, GpxTrackTreeModel))
#define GPX_TRACK_TREE_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPX_TYPE_TRACK_TREE_MODEL, GpxTrackTreeModelClass))
#define GPX_IS_TRACK_TREE_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPX_TYPE_TRACK_TREE_MODEL))
#define GPX_IS_TRACK_TREE_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPX_TYPE_TRACK_TREE_MODEL))
#define GPX_TRACK_TREE_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPX_TYPE_TRACK_TREE_MODEL, GpxTrackTreeModelClass))

typedef struct _GpxTrackTreeModel GpxTrackTreeModel;
typedef struct _GpxTrackTreeModelClass GpxTrackTreeModelClass;
typedef struct _GpxTrackTreeModelPrivate GpxTrackTreeModelPrivate;

#define GPX_TYPE_TRACK (gpx_track_get_type ())
#define GPX_TRACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPX_TYPE_TRACK, GpxTrack))
#define GPX_TRACK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPX_TYPE_TRACK, GpxTrackClass))
#define GPX_IS_TRACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPX_TYPE_TRACK))
#define GPX_IS_TRACK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPX_TYPE_TRACK))
#define GPX_TRACK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPX_TYPE_TRACK, GpxTrackClass))

typedef struct _GpxTrack GpxTrack;
typedef struct _GpxTrackClass GpxTrackClass;

#define GPX_TRACK_TREE_MODEL_TYPE_COLUMN (gpx_track_tree_model_column_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _GpxTrackPrivate GpxTrackPrivate;

#define GPX_TYPE_POINT (gpx_point_get_type ())
#define GPX_POINT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPX_TYPE_POINT, GpxPoint))
#define GPX_POINT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPX_TYPE_POINT, GpxPointClass))
#define GPX_IS_POINT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPX_TYPE_POINT))
#define GPX_IS_POINT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPX_TYPE_POINT))
#define GPX_POINT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPX_TYPE_POINT, GpxPointClass))

typedef struct _GpxPoint GpxPoint;
typedef struct _GpxPointClass GpxPointClass;
#define _gpx_point_unref0(var) ((var == NULL) ? NULL : (var = (gpx_point_unref (var), NULL)))
#define _gtk_tree_path_free0(var) ((var == NULL) ? NULL : (var = (gtk_tree_path_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _GpxPointPrivate GpxPointPrivate;

struct _GpxTrackTreeModel {
	GObject parent_instance;
	GpxTrackTreeModelPrivate * priv;
};

struct _GpxTrackTreeModelClass {
	GObjectClass parent_class;
};

struct _GpxTrackTreeModelPrivate {
	GType* ColumnType;
	gint ColumnType_length1;
	gint _ColumnType_size_;
	gint stamp;
	GpxTrack* track;
};

typedef enum  {
	GPX_TRACK_TREE_MODEL_COLUMN_TIME,
	GPX_TRACK_TREE_MODEL_COLUMN_DISTANCE,
	GPX_TRACK_TREE_MODEL_COLUMN_ELEVATION,
	GPX_TRACK_TREE_MODEL_COLUMN_SPEED,
	GPX_TRACK_TREE_MODEL_COLUMN_NUM_COLUMNS
} GpxTrackTreeModelColumn;

struct _GpxTrack {
	GObject parent_instance;
	GpxTrackPrivate * priv;
	double total_distance;
	double max_speed;
	GList* points;
	GpxPoint* top;
	GpxPoint* bottom;
	double max_elevation;
	double min_elevation;
};

struct _GpxTrackClass {
	GObjectClass parent_class;
};

struct _GpxPoint {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GpxPointPrivate * priv;
	double lat;
	double lon;
	double lat_dec;
	double lon_dec;
	double distance;
	double elevation;
	char* time;
	double speed;
};

struct _GpxPointClass {
	GTypeClass parent_class;
	void (*finalize) (GpxPoint *self);
};


static gpointer gpx_track_tree_model_parent_class = NULL;
static GtkTreeModelIface* gpx_track_tree_model_gtk_tree_model_parent_iface = NULL;

GType gpx_track_tree_model_get_type (void) G_GNUC_CONST;
GType gpx_track_get_type (void) G_GNUC_CONST;
#define GPX_TRACK_TREE_MODEL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GPX_TYPE_TRACK_TREE_MODEL, GpxTrackTreeModelPrivate))
enum  {
	GPX_TRACK_TREE_MODEL_DUMMY_PROPERTY
};
GType gpx_track_tree_model_column_get_type (void) G_GNUC_CONST;
GpxTrackTreeModel* gpx_track_tree_model_new (GpxTrack* track);
GpxTrackTreeModel* gpx_track_tree_model_construct (GType object_type, GpxTrack* track);
static GType gpx_track_tree_model_real_get_column_type (GtkTreeModel* base, gint index_);
gpointer gpx_point_ref (gpointer instance);
void gpx_point_unref (gpointer instance);
GParamSpec* gpx_param_spec_point (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void gpx_value_set_point (GValue* value, gpointer v_object);
void gpx_value_take_point (GValue* value, gpointer v_object);
gpointer gpx_value_get_point (const GValue* value);
GType gpx_point_get_type (void) G_GNUC_CONST;
static gboolean gpx_track_tree_model_real_get_iter (GtkTreeModel* base, GtkTreeIter* iter, GtkTreePath* path);
static gint gpx_track_tree_model_real_get_n_columns (GtkTreeModel* base);
static GtkTreePath* gpx_track_tree_model_real_get_path (GtkTreeModel* base, GtkTreeIter* iter);
time_t gpx_point_get_time (GpxPoint* self);
static void gpx_track_tree_model_real_get_value (GtkTreeModel* base, GtkTreeIter* iter, gint column, GValue* value);
static gboolean gpx_track_tree_model_real_iter_children (GtkTreeModel* base, GtkTreeIter* iter, GtkTreeIter* parent);
static gboolean gpx_track_tree_model_real_iter_has_child (GtkTreeModel* base, GtkTreeIter* iter);
static gint gpx_track_tree_model_real_iter_n_children (GtkTreeModel* base, GtkTreeIter* iter);
static GtkTreeModelFlags gpx_track_tree_model_real_get_flags (GtkTreeModel* base);
static gboolean gpx_track_tree_model_real_iter_next (GtkTreeModel* base, GtkTreeIter* iter);
static gboolean gpx_track_tree_model_real_iter_nth_child (GtkTreeModel* base, GtkTreeIter* iter, GtkTreeIter* parent, gint n);
static gboolean gpx_track_tree_model_real_iter_parent (GtkTreeModel* base, GtkTreeIter* iter, GtkTreeIter* child);
static void gpx_track_tree_model_real_ref_node (GtkTreeModel* base, GtkTreeIter* iter);
static void gpx_track_tree_model_real_unref_node (GtkTreeModel* base, GtkTreeIter* iter);
static void gpx_track_tree_model_finalize (GObject* obj);



GType gpx_track_tree_model_column_get_type (void) {
	static volatile gsize gpx_track_tree_model_column_type_id__volatile = 0;
	if (g_once_init_enter (&gpx_track_tree_model_column_type_id__volatile)) {
		static const GEnumValue values[] = {{GPX_TRACK_TREE_MODEL_COLUMN_TIME, "GPX_TRACK_TREE_MODEL_COLUMN_TIME", "time"}, {GPX_TRACK_TREE_MODEL_COLUMN_DISTANCE, "GPX_TRACK_TREE_MODEL_COLUMN_DISTANCE", "distance"}, {GPX_TRACK_TREE_MODEL_COLUMN_ELEVATION, "GPX_TRACK_TREE_MODEL_COLUMN_ELEVATION", "elevation"}, {GPX_TRACK_TREE_MODEL_COLUMN_SPEED, "GPX_TRACK_TREE_MODEL_COLUMN_SPEED", "speed"}, {GPX_TRACK_TREE_MODEL_COLUMN_NUM_COLUMNS, "GPX_TRACK_TREE_MODEL_COLUMN_NUM_COLUMNS", "num-columns"}, {0, NULL, NULL}};
		GType gpx_track_tree_model_column_type_id;
		gpx_track_tree_model_column_type_id = g_enum_register_static ("GpxTrackTreeModelColumn", values);
		g_once_init_leave (&gpx_track_tree_model_column_type_id__volatile, gpx_track_tree_model_column_type_id);
	}
	return gpx_track_tree_model_column_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


GpxTrackTreeModel* gpx_track_tree_model_construct (GType object_type, GpxTrack* track) {
	GpxTrackTreeModel * self;
	GpxTrack* _tmp0_;
	g_return_val_if_fail (track != NULL, NULL);
	self = (GpxTrackTreeModel*) g_object_new (object_type, NULL);
	self->priv->track = (_tmp0_ = _g_object_ref0 (track), _g_object_unref0 (self->priv->track), _tmp0_);
	return self;
}


GpxTrackTreeModel* gpx_track_tree_model_new (GpxTrack* track) {
	return gpx_track_tree_model_construct (GPX_TYPE_TRACK_TREE_MODEL, track);
}


static GType gpx_track_tree_model_real_get_column_type (GtkTreeModel* base, gint index_) {
	GpxTrackTreeModel * self;
	GType result = 0UL;
	self = (GpxTrackTreeModel*) base;
	result = self->priv->ColumnType[index_];
	return result;
}


static gpointer _gpx_point_ref0 (gpointer self) {
	return self ? gpx_point_ref (self) : NULL;
}


static gboolean gpx_track_tree_model_real_get_iter (GtkTreeModel* base, GtkTreeIter* iter, GtkTreePath* path) {
	GpxTrackTreeModel * self;
	gboolean result = FALSE;
	gint depth;
	gint n;
	gboolean _tmp0_ = FALSE;
	GpxPoint* p;
	self = (GpxTrackTreeModel*) base;
	g_return_val_if_fail (path != NULL, FALSE);
	depth = gtk_tree_path_get_depth (path);
	g_assert (depth == 1);
	n = gtk_tree_path_get_indices (path)[0];
	if (n >= 0) {
		_tmp0_ = n < g_list_length (self->priv->track->points);
	} else {
		_tmp0_ = FALSE;
	}
	g_assert (_tmp0_);
	p = _gpx_point_ref0 ((GpxPoint*) g_list_nth_data (self->priv->track->points, (guint) n));
	(*iter).stamp = self->priv->stamp;
	(*iter).user_data = p;
	(*iter).user_data2 = NULL;
	(*iter).user_data3 = NULL;
	result = TRUE;
	_gpx_point_unref0 (p);
	return result;
}


static gint gpx_track_tree_model_real_get_n_columns (GtkTreeModel* base) {
	GpxTrackTreeModel * self;
	gint result = 0;
	self = (GpxTrackTreeModel*) base;
	result = (gint) GPX_TRACK_TREE_MODEL_COLUMN_NUM_COLUMNS;
	return result;
}


static GtkTreePath* gpx_track_tree_model_real_get_path (GtkTreeModel* base, GtkTreeIter* iter) {
	GpxTrackTreeModel * self;
	GtkTreePath* result = NULL;
	void* _tmp0_;
	GpxPoint* p;
	GtkTreePath* path;
	gint pos;
	self = (GpxTrackTreeModel*) base;
	g_assert ((*iter).user_data != NULL);
	p = _gpx_point_ref0 ((_tmp0_ = (*iter).user_data, GPX_IS_POINT (_tmp0_) ? ((GpxPoint*) _tmp0_) : NULL));
	path = gtk_tree_path_new ();
	pos = g_list_index (self->priv->track->points, p);
	g_assert (pos != (-1));
	gtk_tree_path_append_index (path, pos);
	result = path;
	_gpx_point_unref0 (p);
	return result;
}


static void g_time_local (time_t time, struct tm* result) {
	struct tm _result_ = {0};
	localtime_r (&time, &_result_);
	*result = _result_;
	return;
}


static char* g_time_format (struct tm *self, const char* format) {
	char* result = NULL;
	gchar* _tmp0_;
	gint _buffer_size_;
	gint buffer_length1;
	gchar* buffer;
	g_return_val_if_fail (format != NULL, NULL);
	buffer = (_tmp0_ = g_new0 (gchar, 64), buffer_length1 = 64, _buffer_size_ = buffer_length1, _tmp0_);
	strftime (buffer, buffer_length1, format, &(*self));
	result = g_strdup ((const char*) buffer);
	buffer = (g_free (buffer), NULL);
	return result;
}


static void gpx_track_tree_model_real_get_value (GtkTreeModel* base, GtkTreeIter* iter, gint column, GValue* value) {
	GpxTrackTreeModel * self;
	void* _tmp0_;
	GpxPoint* p;
	GValue _tmp2_;
	GValue _tmp1_ = {0};
	self = (GpxTrackTreeModel*) base;
	g_assert ((*iter).user_data != NULL);
	p = _gpx_point_ref0 ((_tmp0_ = (*iter).user_data, GPX_IS_POINT (_tmp0_) ? ((GpxPoint*) _tmp0_) : NULL));
	*value = (_tmp2_ = (g_value_init (&_tmp1_, gtk_tree_model_get_column_type ((GtkTreeModel*) self, column)), _tmp1_), G_IS_VALUE (value) ? (g_value_unset (value), NULL) : NULL, _tmp2_);
	switch (column) {
		case GPX_TRACK_TREE_MODEL_COLUMN_TIME:
		{
			struct tm _tmp3_ = {0};
			struct tm t;
			char* _tmp4_;
			t = (g_time_local (gpx_point_get_time (p), &_tmp3_), _tmp3_);
			g_value_set_string (value, _tmp4_ = g_time_format (&t, "%D - %X"));
			_g_free0 (_tmp4_);
			break;
		}
		case GPX_TRACK_TREE_MODEL_COLUMN_DISTANCE:
		{
			g_value_set_double (value, p->distance);
			break;
		}
		case GPX_TRACK_TREE_MODEL_COLUMN_ELEVATION:
		{
			g_value_set_double (value, p->elevation);
			break;
		}
		case GPX_TRACK_TREE_MODEL_COLUMN_SPEED:
		{
			g_value_set_double (value, p->speed);
			break;
		}
		default:
		{
			break;
		}
	}
	_gpx_point_unref0 (p);
}


static gboolean gpx_track_tree_model_real_iter_children (GtkTreeModel* base, GtkTreeIter* iter, GtkTreeIter* parent) {
	GpxTrackTreeModel * self;
	gboolean result = FALSE;
	self = (GpxTrackTreeModel*) base;
	result = FALSE;
	return result;
}


static gboolean gpx_track_tree_model_real_iter_has_child (GtkTreeModel* base, GtkTreeIter* iter) {
	GpxTrackTreeModel * self;
	gboolean result = FALSE;
	self = (GpxTrackTreeModel*) base;
	result = FALSE;
	return result;
}


static gint gpx_track_tree_model_real_iter_n_children (GtkTreeModel* base, GtkTreeIter* iter) {
	GpxTrackTreeModel * self;
	gint result = 0;
	self = (GpxTrackTreeModel*) base;
	if (iter == NULL) {
		guint n_children;
		n_children = g_list_length (self->priv->track->points);
		result = (gint) n_children;
		return result;
	} else {
		result = 0;
		return result;
	}
}


static GtkTreeModelFlags gpx_track_tree_model_real_get_flags (GtkTreeModel* base) {
	GpxTrackTreeModel * self;
	GtkTreeModelFlags result = 0;
	GtkTreeModelFlags flags;
	self = (GpxTrackTreeModel*) base;
	flags = GTK_TREE_MODEL_LIST_ONLY | GTK_TREE_MODEL_ITERS_PERSIST;
	result = flags;
	return result;
}


static gboolean gpx_track_tree_model_real_iter_next (GtkTreeModel* base, GtkTreeIter* iter) {
	GpxTrackTreeModel * self;
	gboolean result = FALSE;
	void* _tmp0_;
	GpxPoint* p;
	GList* node;
	gboolean _tmp1_ = FALSE;
	self = (GpxTrackTreeModel*) base;
	g_assert ((*iter).user_data != NULL);
	p = _gpx_point_ref0 ((_tmp0_ = (*iter).user_data, GPX_IS_POINT (_tmp0_) ? ((GpxPoint*) _tmp0_) : NULL));
	node = g_list_find (self->priv->track->points, p);
	if (node != NULL) {
		_tmp1_ = node->next != NULL;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		(*iter).stamp = self->priv->stamp;
		(*iter).user_data = node->next->data;
		result = TRUE;
		_gpx_point_unref0 (p);
		return result;
	}
	result = FALSE;
	_gpx_point_unref0 (p);
	return result;
}


static gboolean gpx_track_tree_model_real_iter_nth_child (GtkTreeModel* base, GtkTreeIter* iter, GtkTreeIter* parent, gint n) {
	GpxTrackTreeModel * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	self = (GpxTrackTreeModel*) base;
	if (parent == NULL) {
		result = FALSE;
		return result;
	}
	if (n < 0) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = n >= g_list_length (self->priv->track->points);
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	(*iter).stamp = self->priv->stamp;
	(*iter).user_data = (GpxPoint*) g_list_nth_data (self->priv->track->points, (guint) n);
	result = TRUE;
	return result;
}


static gboolean gpx_track_tree_model_real_iter_parent (GtkTreeModel* base, GtkTreeIter* iter, GtkTreeIter* child) {
	GpxTrackTreeModel * self;
	gboolean result = FALSE;
	self = (GpxTrackTreeModel*) base;
	result = FALSE;
	return result;
}


static void gpx_track_tree_model_real_ref_node (GtkTreeModel* base, GtkTreeIter* iter) {
	GpxTrackTreeModel * self;
	self = (GpxTrackTreeModel*) base;
}


static void gpx_track_tree_model_real_unref_node (GtkTreeModel* base, GtkTreeIter* iter) {
	GpxTrackTreeModel * self;
	self = (GpxTrackTreeModel*) base;
}


static void gpx_track_tree_model_class_init (GpxTrackTreeModelClass * klass) {
	gpx_track_tree_model_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GpxTrackTreeModelPrivate));
	G_OBJECT_CLASS (klass)->finalize = gpx_track_tree_model_finalize;
}


static void gpx_track_tree_model_gtk_tree_model_interface_init (GtkTreeModelIface * iface) {
	gpx_track_tree_model_gtk_tree_model_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_column_type = gpx_track_tree_model_real_get_column_type;
	iface->get_iter = gpx_track_tree_model_real_get_iter;
	iface->get_n_columns = gpx_track_tree_model_real_get_n_columns;
	iface->get_path = gpx_track_tree_model_real_get_path;
	iface->get_value = gpx_track_tree_model_real_get_value;
	iface->iter_children = gpx_track_tree_model_real_iter_children;
	iface->iter_has_child = gpx_track_tree_model_real_iter_has_child;
	iface->iter_n_children = gpx_track_tree_model_real_iter_n_children;
	iface->get_flags = gpx_track_tree_model_real_get_flags;
	iface->iter_next = gpx_track_tree_model_real_iter_next;
	iface->iter_nth_child = gpx_track_tree_model_real_iter_nth_child;
	iface->iter_parent = gpx_track_tree_model_real_iter_parent;
	iface->ref_node = gpx_track_tree_model_real_ref_node;
	iface->unref_node = gpx_track_tree_model_real_unref_node;
}


static void gpx_track_tree_model_instance_init (GpxTrackTreeModel * self) {
	GType* _tmp0_ = NULL;
	self->priv = GPX_TRACK_TREE_MODEL_GET_PRIVATE (self);
	self->priv->ColumnType = (_tmp0_ = g_new0 (GType, 4), _tmp0_[0] = G_TYPE_STRING, _tmp0_[1] = G_TYPE_DOUBLE, _tmp0_[2] = G_TYPE_DOUBLE, _tmp0_[3] = G_TYPE_DOUBLE, _tmp0_);
	self->priv->ColumnType_length1 = 4;
	self->priv->_ColumnType_size_ = self->priv->ColumnType_length1;
	self->priv->stamp = 42;
	self->priv->track = NULL;
}


static void gpx_track_tree_model_finalize (GObject* obj) {
	GpxTrackTreeModel * self;
	self = GPX_TRACK_TREE_MODEL (obj);
	self->priv->ColumnType = (g_free (self->priv->ColumnType), NULL);
	_g_object_unref0 (self->priv->track);
	G_OBJECT_CLASS (gpx_track_tree_model_parent_class)->finalize (obj);
}


GType gpx_track_tree_model_get_type (void) {
	static volatile gsize gpx_track_tree_model_type_id__volatile = 0;
	if (g_once_init_enter (&gpx_track_tree_model_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GpxTrackTreeModelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpx_track_tree_model_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GpxTrackTreeModel), 0, (GInstanceInitFunc) gpx_track_tree_model_instance_init, NULL };
		static const GInterfaceInfo gtk_tree_model_info = { (GInterfaceInitFunc) gpx_track_tree_model_gtk_tree_model_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType gpx_track_tree_model_type_id;
		gpx_track_tree_model_type_id = g_type_register_static (G_TYPE_OBJECT, "GpxTrackTreeModel", &g_define_type_info, 0);
		g_type_add_interface_static (gpx_track_tree_model_type_id, GTK_TYPE_TREE_MODEL, &gtk_tree_model_info);
		g_once_init_leave (&gpx_track_tree_model_type_id__volatile, gpx_track_tree_model_type_id);
	}
	return gpx_track_tree_model_type_id__volatile;
}




